<?php

// include WordPress
define( 'WP_USE_THEMES', false );
require('../../../wp-load.php');

global $ocart;

  //reading raw POST data from input stream. reading pot data from $_POST may cause serialization issues since POST data may contain arrays
  $raw_post_data = file_get_contents('php://input');
  $raw_post_array = explode('&', $raw_post_data);
  $myPost = array();
  foreach ($raw_post_array as $keyval)
  {
      $keyval = explode ('=', $keyval);
      if (count($keyval) == 2)
         $myPost[$keyval[0]] = urldecode($keyval[1]);
  }
  // read the post from PayPal system and add 'cmd'
  $req = 'cmd=_notify-validate';
  if(function_exists('get_magic_quotes_gpc'))
  {
       $get_magic_quotes_exits = true;
  } 
  foreach ($myPost as $key => $value)
  {        
       if($get_magic_quotes_exits == true && get_magic_quotes_gpc() == 1)
       { 
            $value = urlencode(stripslashes($value)); 
       }
       else
       {
            $value = urlencode($value);
       }
       $req .= "&$key=$value";
  }

if ($ocart['paypal_testmode'] == 1) {
	$url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
} else {
	$url = 'https://www.paypal.com/cgi-bin/webscr';
}  

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: www.paypal.com'));
// In wamp like environment where the root authority certificate doesn't comes in the bundle, you need
// to download 'cacert.pem' from "http://curl.haxx.se/docs/caextract.html" and set the directory path 
// of the certificate as shown below.
// curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
$res = curl_exec($ch);
curl_close($ch);
 
// assign posted variables to local variables
$item_name = $_POST['item_name'];
$order_id = $_POST['item_number'];
$payment_status = $_POST['payment_status'];
$payment_amount = $_POST['mc_gross'];
$payment_currency = $_POST['mc_currency'];
$txn_id = $_POST['txn_id'];
$receiver_email = $_POST['receiver_email'];
$payer_email = $_POST['payer_email'];


if (strcmp ($res, "VERIFIED") == 0) {
	// check the payment_status is Completed
	if ($payment_status != 'Completed') {
		exit;
	}
	// check that txn_id has not been previously processed
	$txn_id_old = get_post_meta($order_id, 'txn_id', true);
	if ($txn_id == $txn_id_old) {
		exit;
	}
	// check that receiver_email is your Primary PayPal email
	if ($receiver_email != $ocart['paypal_receiver_email']) {
		exit;
	}
	// check that payment_amount is correct
	$payment_amount_old = get_post_meta($order_id, 'payment_gross_total', true);
	if ($payment_amount != $payment_amount_old) {
		exit;
	}
	// check that currency is correct
	if ($payment_currency != $ocart['currencycode']) {
		exit;
	}
	
	// process payment
	if (!isset($notes)) { $notes = ''; }
	update_post_meta($order_id, 'payment_status', $payment_status);
	update_post_meta($order_id, 'order_status', 'pending');
	wp_mail(get_the_author_meta( 'user_email', get_post_meta($order_id, 'custID', true) ), sprintf(__('[%s] Your Order is Pending','ocart'), get_bloginfo('name')), ocart_email_template('order_pending', $order_id, $notes));
	update_post_meta($order_id, 'order_status_dump', 'pending');

}
else if (strcmp ($res, "INVALID") == 0) {
	// log for manual investigation
}
?>