<?php

/**
@Shows the gateway form and starts a transaction!
*/
function ocart_print_paypal_form($post_id, $location = '') {
	
	global $ocart;
	
	// test mode check
	if ($ocart['paypal_testmode'] == 1) {
		$url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
	} else {
		$url = 'https://www.paypal.com/cgi-bin/webscr';
	}
	
	// print form
	$form = '';
		
	$form .= '<form name="_xclick" action="'.$url.'" method="post" class="paymentform">
				<input type="hidden" name="cmd" value="_xclick">
				<input type="hidden" name="business" value="'.$ocart['paypal_receiver_email'].'">
				<input type="hidden" name="currency_code" value="'.ocart_get_currency_code().'">
				<input type="hidden" name="item_name" value="'.sprintf(__('%s Payment for Invoice #%s','ocart'), get_bloginfo('name'), $post_id).'">
				<input type="hidden" name="item_number" value="'.$post_id.'">
				<input type="hidden" name="amount" value="'.ocart_payable($post_id).'">
				<input type="hidden" name="return" value="'.home_url().'">
				<input type="hidden" name="lc" value="US"> 
				<input type="hidden" name="notify_url" value="'.PLUGIN_OCART_PAYPAL_URL.'ipn.php">';
				
	if ($ocart['paypal_testmode'] == 1) {
		$form .= '<input type="hidden" name="test_ipn" value="1" />';
	}
	
	if ($location == 'invoice') {
	$form .= '<input type="image" name="submit" border="0" src="https://www.paypal.com/en_US/i/btn/btn_buynow_LG.gif" alt="PayPal - The safer, easier way to pay online">  
				</form>';
	} else {
	$form .= '<input type="submit" name="submit" value="'.__('Pay with PayPal','ocart').'" />
				</form>';
	}
				
	return $form;

}